lam_true = lambda x : lambda y : x 
lam_false = lambda x : lambda y : y 
lam_if = lambda p : lambda c : lambda a : (p(c))(a) 

# print lam_if(lam_true)("true works")("wat!?") 

lam_and = lambda x : lambda y : lam_if(x)(y)(lam_false) 
lam_or = lambda x : lambda y : lam_if(x)(lam_true)(y) 

# my_predicate = lam_or(lam_true)(lam_false) 
# print lam_if(my_predicate)("(true or false) works")("wat!?") 

lam_null = lambda x : lam_true
lam_is_null = lambda x : x(lambda y : lambda z : lam_false) 

lam_cons = lambda x : lambda y : lambda z : z(x)(y) 
lam_car = lambda p : p(lam_true) 
lam_cdr = lambda p : p(lam_false) 

# print lam_if (lam_is_null(lam_null)) ("null is null")("wat!?") 
# print lam_if (lam_is_null(lam_cons(lam_null)(lam_null))) ("wat!?")("good") 

lam_succ = lambda x : lam_cons(lam_false)(x) 
lam_pred = lambda x : lam_cdr(x) 

lam_zero = lam_null
lam_is_zero = lam_is_null
lam_one = lam_cons(lam_false)(lam_zero) 
lam_two = lam_cons(lam_false)(lam_one) 
lam_three = lam_cons(lam_false)(lam_two) 

def lam_num_to_python_num(n):
        if n == lam_zero:
                return 0
        else:
                return 1 + lam_num_to_python_num(lam_pred(n))
                        
# print lam_num_to_python_num(lam_zero) 
# print lam_num_to_python_num(lam_one) 
# print lam_num_to_python_num(lam_two) 
# print lam_num_to_python_num(lam_three) 

def lam_add(x,y):
        if x == lam_zero: 
                return y
        else:
                return lam_add(lam_pred(x), lam_succ(y)) 

lam_two_plus_three = lam_add(lam_two,lam_three) 

# print lam_num_to_python_num(lam_two_plus_three) 

lam_six = lam_add(lam_three,lam_three) 
lam_twelve = lam_add(lam_six,lam_six) 
lam_twenty_four = lam_add(lam_twelve,lam_twelve) 
lam_thirty_six = lam_add(lam_twenty_four,lam_twelve)
lam_forty_two = lam_add(lam_thirty_six,lam_six)
# print lam_num_to_python_num(lam_forty_two) 


def lam_mul(x,y):
        if x == lam_zero: 
                return lam_zero
        else:
                return lam_add(y, lam_mul(lam_pred(x), y))

lam_eighteen = lam_mul(lam_six, lam_three) 
# print lam_num_to_python_num(lam_eighteen) 


